Sketcher ConstrainSnellsLaw/pl: Difference between revisions

From FreeCAD Documentation
(Created page with "Wiązanie może być utworzone przez makropolecenie i z konsoli Pyton za pomocą następującej funkcji:")
(Created page with "gdzie: :* <tt>Sketch</tt> jest obiektem typu szkic :* <tt>line1</tt> oraz <tt>pointpos1</tt> są dwiema liczbami całkowitymi określającymi punkt końcowy linii w środku o...")
Line 55: Line 55:
Sketch.addConstraint(Sketcher.Constraint('SnellsLaw',line1,pointpos1,line2,pointpos2,interface,n2byn1))
Sketch.addConstraint(Sketcher.Constraint('SnellsLaw',line1,pointpos1,line2,pointpos2,interface,n2byn1))
}}
}}
gdzie:
where:
:* <tt>Sketch</tt> is a sketch object
:* <tt>Sketch</tt> jest obiektem typu szkic
:* <tt>line1</tt> and <tt>pointpos1</tt> are two integers identifying the endpoint of the line in medium with refractive index of ''n1''. <tt>line1</tt> is the line's index in the sketch (the value, returned by Sketch.addGeometry), and <tt>pointpos1</tt> should be 1 for start point and 2 for end point.
:* <tt>line1</tt> oraz <tt>pointpos1</tt> dwiema liczbami całkowitymi określającymi punkt końcowy linii w środku o współczynniku załamania światła wynoszącym ''n1''. <tt>line1</tt> jest indeksem linii w szkicu ''(wartość zwracana przez Sketch.addGeometry)'', a <tt>pointpos1</tt> powinno wynosić 1 dla punktu początkowego i 2 dla punktu końcowego,
:* <tt>line2</tt> and <tt>pointpos2</tt> are the indexes specifying the endpoint of the second line (in medium ''n2'')
:* <tt>line2</tt> oraz <tt>pointpos2</tt> to indeksy określające punkt końcowy drugiej linii ''(w środku „n2”)'',
:* <tt>n2byn1</tt> is a floating-point number equal to the ratio of refractive indices ''n2''/''n1''
:* <tt>n2byn1</tt> jest liczbą zmiennoprzecinkową równą stosunkowi współczynników załamania światła ''n2''/''n1''.


Przykład:
Przykład:

Revision as of 17:28, 7 November 2020

Szkicownik: Wiązanie prawo Snella

Lokalizacja w menu
Szkicownik → Wiązania Szkicownika → Wiązanie refrakcji (prawo Snell'a)
Środowisko pracy
Szkicownik
Domyślny skrót
brak
Wprowadzono w wersji
0.15
Zobacz także
brak

Opis

Constrains two lines to follow the law of refraction of light as it penetrates through an interface, where two materials of different refraction indices meet. See Snell's law on Wikipedia for more info.

Snell's Law

Usage

The sequence of clicks is indicated by yellow arrows with numbers. n1, n2 are only labels to show where the indices of refraction are.

  • You will need two lines that are to follow a beam of light, and a curve to act as an interface. The lines should be on different sides of the interface.
  • Select the endpoint of one line, an endpoint of another line, and the interface edge. The interface can be a line, circle/arc, ellipse/arc of ellipse. Note the order you've selected the endpoints.
  • Invoke the constraint. A dialog will appear asking for a ratio of indices of refraction n2/n1. n2 corresponds to the medium where the second selected endpoint's line resides, n1 is for the first line.
  • The endpoints will be made coincident (if needed), constrained onto the interface (if needed), and the Snell's law will become constrained.

Note that several helper constraints will be added automatically (point-on-object, coincident). They can be deleted if they cause redundancy or added manually if they were not added automatically. For the actual Snell's law constraint the endpoints of lines must coincide and lay on the interface, otherwise the behavior is undefined.

Using the Polyline, it is possible to speed up drawing rays of light. In this case one can select two coincident endpoints by box selection.

Remarks

  • The actual Snell's law constraint enforces the plain law equation n1*sin(theta1) = n2*sin(theta2). It needs the line ends to be made coincident and on the interface by other constraints. The necessary helper constraints are added automatically based on the current coordinates of the elements.
  • Python routine does not add the helper constraints. These must be added manually by the script (see example in Scripting section).
  • These helper constraints can be temporarily deleted and the endpoints dragged apart, which can be useful in case one wants to construct a reflected ray or birefringence rays.
  • Unlike the reality, refraction indices are associated with rays of light, but not according to the sides of the boundary. This is useful to emulate birefringence, construct paths of different wavelengths due to refraction, and easily construct angle of onset of total internal reflection.
  • Both rays can be on the same side of the interface, satisfying the constraint equation. This is physical nonsense, unless the ratio n2/n1 is 1.0, in which case the constraint emulates a reflection.
  • Arcs of circle and ellipse are also accepted as rays (physical nonsense).

Tworzenie skryptów

Wiązanie może być utworzone przez makropolecenie i z konsoli Pyton za pomocą następującej funkcji:

Sketch.addConstraint(Sketcher.Constraint('SnellsLaw',line1,pointpos1,line2,pointpos2,interface,n2byn1))

gdzie:

  • Sketch jest obiektem typu szkic
  • line1 oraz pointpos1 są dwiema liczbami całkowitymi określającymi punkt końcowy linii w środku o współczynniku załamania światła wynoszącym n1. line1 jest indeksem linii w szkicu (wartość zwracana przez Sketch.addGeometry), a pointpos1 powinno wynosić 1 dla punktu początkowego i 2 dla punktu końcowego,
  • line2 oraz pointpos2 to indeksy określające punkt końcowy drugiej linii (w środku „n2”),
  • n2byn1 jest liczbą zmiennoprzecinkową równą stosunkowi współczynników załamania światła n2/n1.

Przykład:

import Sketcher
import Part
import FreeCAD

StartPoint = 1
EndPoint = 2
MiddlePoint = 3

f = App.activeDocument().addObject("Sketcher::SketchObject","Sketch")

# add geometry to the sketch
icir = f.addGeometry(Part.Circle(App.Vector(-547.612366,227.479736,0),App.Vector(0,0,1),68.161979))
iline1 = f.addGeometry(Part.LineSegment(App.Vector(-667.331726,244.127090,0),App.Vector(-604.284241,269.275238,0)))
iline2 = f.addGeometry(Part.LineSegment(App.Vector(-604.284241,269.275238,0),App.Vector(-490.940491,256.878265,0)))
# add constraints
# helper constraints:
f.addConstraint(Sketcher.Constraint('Coincident',iline1,EndPoint,iline2,StartPoint)) 
f.addConstraint(Sketcher.Constraint('PointOnObject',iline1,EndPoint,icir)) 
# the Snell's law:
f.addConstraint(Sketcher.Constraint('SnellsLaw',iline1,EndPoint,iline2,StartPoint,icir,1.47))

App.ActiveDocument.recompute()